
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "bitman1.vec"
	.INCLUDE "bitman1.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

	OUT  RAMPZ,R24

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500
;       1 /*
;       2 project     : Dotmatrix 8*8  BITMAN ǥ α׷
;       3               bitman1.c
;       4 Date        : 2008-09-12
;       5 Company     : AvrMall.com
;       6 Chip type   : ATmega128-16au
;       7 Clock       : 16.000000 MHz
;       8 Comment     :
;       9 BITMAN ̴ α׷̴.    Ѵ.
;      10 CL0~7 aTmega128 PORTB(line),  RW0~7 aTmega128 PORTC(LED) Ѵ.
;      11 */
;      12 
;      13 #include <mega128.h>
;      14 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      15 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      16 	.EQU __se_bit=0x20
	.EQU __se_bit=0x20
;      17 	.EQU __sm_mask=0x1C
	.EQU __sm_mask=0x1C
;      18 	.EQU __sm_powerdown=0x10
	.EQU __sm_powerdown=0x10
;      19 	.EQU __sm_powersave=0x18
	.EQU __sm_powersave=0x18
;      20 	.EQU __sm_standby=0x14
	.EQU __sm_standby=0x14
;      21 	.EQU __sm_ext_standby=0x1C
	.EQU __sm_ext_standby=0x1C
;      22 	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_adc_noise_red=0x08
;      23 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      24 	#endif
	#endif
;      25 #include <delay.h>
;      26 
;      27 typedef unsigned char u08;
;      28 typedef unsigned int  u16;
;      29 
;      30 #define DELAY 100
;      31 
;      32 unsigned char line=0;
;      33 unsigned char patt=0;
;      34 unsigned char mod=0, num_mod=0;
;      35 
;      36 unsigned char time=0;
;      37 unsigned char delay=DELAY;
;      38 
;      39 unsigned char dir=3;
;      40 unsigned char temp_led, temp_line;
;      41 unsigned char temp_dir;
;      42 unsigned int dir_cnt=0;
_dir_cnt:
	.BYTE 0x2
;      43 
;      44 unsigned char dir_chk_sw=0;
_dir_chk_sw:
	.BYTE 0x1
;      45 
;      46 unsigned char mov_chk_sw=1;           // üũ(    .)
_mov_chk_sw:
	.BYTE 0x1
;      47 unsigned char mov_chk_cnt=0;
_mov_chk_cnt:
	.BYTE 0x1
;      48 
;      49 unsigned char name_sw=0;
_name_sw:
	.BYTE 0x1
;      50 
;      51 /*
;      52 迭 P  ۵ Ʈ Ʈ ǥõǴ ̰(ϳϳ )
;      53 迭 M  ۵  Ͽ ϳ  ǵ Ѵ.
;      54 */
;      55 
;      56 flash unsigned char M[6][25]={

	.CSEG
;      57     {1,2,3,4,5,6,5,4,3,2,1,7,8,9,10,11,10,9,8,7,1,0,0,0,0},
;      58     {12,13,14,13,12,13,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
;      59     {15,16,17,16,15,18,19,18,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
;      60     {20,21,22,21,20,23,24,23,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
;      61     {25,26,27,28,29,30,31,32,29,30,31,32,0,0,0,0,0,0,0,0,0,0,0,0,0},
;      62     {33,34,35,36,37,38,39,40,37,38,39,40,41,42,41,42,0,0,0,0,0,0,0,0,0}
;      63 };
;      64 
;      65 flash unsigned char P[43][8]={
;      66     {0x18,0x18,0x3c,0x5a,0x5a,0x24,0x24,0x66},
;      67     {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
;      68     {0x18,0x18,0x3C,0xDA,0x1A,0x24,0x24,0x66},
;      69     {0x0C,0xCC,0x3C,0x1A,0x1A,0x24,0x26,0x62},
;      70     {0x8C,0x4C,0x3C,0x1A,0x1A,0x24,0x27,0x60},
;      71 
;      72     {0x4C,0x4C,0x3C,0x1A,0x1A,0x24,0x27,0x60},
;      73     {0x2C,0x4C,0x3C,0x1A,0x1A,0x24,0x27,0x60},
;      74     {0x18,0x18,0x3C,0x5B,0x58,0x24,0x24,0x66},
;      75     {0x30,0x33,0x3C,0x58,0x58,0x24,0x24,0x66},
;      76     {0x31,0x32,0x3C,0x58,0x58,0x24,0xE4,0x06},
;      77 
;      78     {0x32,0x32,0x3C,0x58,0x58,0x24,0xE4,0x06},
;      79     {0x34,0x32,0x3C,0x58,0x58,0x24,0xE4,0x06},
;      80     {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
;      81     {0x00,0x18,0x7E,0x99,0x18,0x3C,0x24,0x66},
;      82     {0x00,0x00,0xDB,0x3C,0x18,0x3C,0x3C,0x66},
;      83 
;      84     {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
;      85     {0x18,0x18,0x3C,0xDA,0x1A,0x24,0x64,0x06},
;      86     {0x30,0x30,0x9C,0x7A,0x19,0x24,0x64,0x06},
;      87     {0x18,0x18,0x3C,0x5B,0x58,0x24,0x26,0x60},
;      88     {0x0C,0x0C,0x39,0x5E,0x98,0x24,0x26,0x60},
;      89 
;      90     {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
;      91     {0x0C,0x0C,0x7C,0x9A,0x1A,0x24,0x26,0x60},
;      92     {0x00,0x06,0xFE,0x1C,0x1A,0x2A,0x28,0x6C},
;      93     {0x30,0x30,0x3E,0x59,0x58,0x24,0x64,0x06},
;      94     {0x00,0x60,0x7F,0x38,0x58,0x54,0x14,0x36},
;      95 
;      96     {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
;      97     {0x18,0x18,0x3E,0x59,0x58,0x24,0x26,0x60},
;      98     {0x0C,0x0C,0x18,0x3C,0x38,0x14,0x36,0x20},
;      99     {0x0C,0x0C,0x38,0x5E,0x58,0x14,0x74,0x46},
;     100     {0x0C,0x0C,0x38,0x3E,0x18,0x78,0x50,0x18},
;     101 
;     102     {0x00,0x0C,0x3C,0x58,0x5C,0x16,0x30,0x20},
;     103     {0x0C,0x0C,0x78,0x9E,0x1C,0x14,0x76,0x40},
;     104     {0x0C,0x0C,0x3F,0x58,0x18,0x34,0x24,0x06},
;     105     {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
;     106     {0x18,0x18,0x7C,0x9A,0x1A,0x24,0x64,0x06},
;     107 
;     108     {0x30,0x30,0x18,0x3C,0x1C,0x28,0x6C,0x04},
;     109     {0x30,0x30,0x1C,0x7A,0x1A,0x28,0x2E,0x62},
;     110     {0x30,0x30,0x7C,0x1A,0x18,0x16,0x12,0x30},
;     111     {0x30,0x30,0x1C,0x7C,0x18,0x1E,0x0A,0x18},
;     112     {0x00,0x30,0x3C,0x1A,0x3A,0x68,0x0C,0x04},
;     113 
;     114     {0x30,0x30,0x1E,0x79,0x38,0x28,0x6E,0x02},
;     115     {0x30,0x30,0xFC,0x1A,0x18,0x2C,0x24,0x60},
;     116     {0x30,0x30,0x3E,0x58,0x1C,0x24,0x26,0x60}
;     117 
;     118 };
;     119 
;     120 //
;     121 interrupt [TIM0_OVF] void timer0_int(void)
;     122 {
_timer0_int:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     123         TCNT0 = 0xe3;  // reload for 448us ticks( : 460us)
	LDI  R30,LOW(227)
	OUT  0x32,R30
;     124 
;     125         switch (dir){			//dir  ǥõǴ  Ѵ.
	MOV  R30,R11
;     126                 case 0:
	CPI  R30,0
	BRNE _0x9
;     127                         temp_led=1<<(7-line);
	LDI  R30,LOW(7)
	SUB  R30,R5
	RJMP _0x1A
;     128                         temp_line=P[patt][line];
;     129                 break;
;     130                 case 2:
_0x9:
	CPI  R30,LOW(0x2)
	BRNE _0xA
;     131                         temp_led=P[patt][line];
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
;     132                         temp_line=1<<line;
;     133                 break;
	RJMP _0x8
;     134                 case 1:
_0xA:
	CPI  R30,LOW(0x1)
	BRNE _0xB
;     135                         temp_led=P[patt][7-line];
	RCALL SUBOPT_0x0
	MOVW R26,R30
	LDI  R30,LOW(7)
	SUB  R30,R5
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x2
;     136                         temp_line=1<<line;
;     137                 break;
	RJMP _0x8
;     138                 case 3:
_0xB:
	CPI  R30,LOW(0x3)
	BRNE _0x8
;     139                         temp_led=1<<line;
	MOV  R30,R5
_0x1A:
	LDI  R26,LOW(1)
	CALL __LSLB12
	MOV  R10,R30
;     140                         temp_line=P[patt][line];
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	LPM  R13,Z
;     141                 break;
;     142         }
_0x8:
;     143 
;     144         PORTB = ~temp_line;
	MOV  R30,R13
	COM  R30
	OUT  0x18,R30
;     145         PORTC = temp_led;     // 
	OUT  0x15,R10
;     146 
;     147 
;     148         if(line==7) line=0;
	LDI  R30,LOW(7)
	CP   R30,R5
	BRNE _0xD
	CLR  R5
;     149         else line++;
	RJMP _0xE
_0xD:
	INC  R5
;     150 
;     151         /*
;     152         //    üũ
;     153         if(dir_chk_sw == 0) {
;     154                 temp_dir = PINA>>6;
;     155                 dir_chk_sw=1;
;     156         }
;     157         if(temp_dir == PINA>>6){
;     158                 if(dir_cnt == 600 ) {
;     159                         dir=temp_dir;
;     160                         dir_cnt=0;
;     161                 }
;     162                 else {
;     163                         dir_cnt++;
;     164                 }
;     165         }
;     166         else {
;     167                 if( delay >5) delay=delay-2;
;     168                 dir_chk_sw=0;
;     169                 dir_cnt=0;
;     170 
;     171                 mov_chk_sw=1;
;     172                 mov_chk_cnt=0;
;     173         }*/
;     174 }
_0xE:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;     175 
;     176 interrupt [TIM2_OVF] void timer2_ovf_isr(void)                  // ٲٱ  Ÿ̸ (Լ )
;     177 {
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     178         TCNT2 = 0xdf;  // reload for 2.048ms ticks( : 2.12ms)
	LDI  R30,LOW(223)
	OUT  0x24,R30
;     179         time++;
	INC  R9
;     180         //PORTD.4 = ~PORTD.4;
;     181 
;     182         if(mov_chk_sw==1 && time >= delay )  //( : 214ms)
	LDS  R26,_mov_chk_sw
	CPI  R26,LOW(0x1)
	BRNE _0x10
	CP   R9,R8
	BRSH _0x11
_0x10:
	RJMP _0xF
_0x11:
;     183         {
;     184                 time=0;
	CLR  R9
;     185                 //PORTD.4 = ~PORTD.4;
;     186 
;     187                 if(M[mod][num_mod] == 0) {      //  
	RCALL SUBOPT_0x4
	LPM  R30,Z
	CPI  R30,0
	BRNE _0x12
;     188                         mod= TCNT0%6;
	IN   R30,0x32
	MOV  R26,R30
	LDI  R30,LOW(6)
	CALL __MODB21U
	MOV  R7,R30
;     189                         num_mod=0;
	CLR  R6
;     190 
;     191                         mov_chk_cnt++;
	LDS  R30,_mov_chk_cnt
	SUBI R30,-LOW(1)
	STS  _mov_chk_cnt,R30
;     192 
;     193                         if(mov_chk_cnt == 10) {
	LDS  R26,_mov_chk_cnt
	CPI  R26,LOW(0xA)
	BRNE _0x13
;     194                         mov_chk_sw=0;
	LDI  R30,LOW(0)
	STS  _mov_chk_sw,R30
;     195                         mov_chk_cnt=0;
	STS  _mov_chk_cnt,R30
;     196                         }
;     197 
;     198                 }
_0x13:
;     199 
;     200                 else {
	RJMP _0x14
_0x12:
;     201                         patt= M[mod][num_mod];      //  
	RCALL SUBOPT_0x4
	LPM  R4,Z
;     202                         num_mod++;
	INC  R6
;     203                         if(delay<= DELAY) delay++;
	LDI  R30,LOW(100)
	CP   R30,R8
	BRLO _0x15
	INC  R8
;     204                 }
_0x15:
_0x14:
;     205         }
;     206 }
_0xF:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     207 
;     208 void main(void)
;     209 {
_main:
;     210         DDRA = 0x00;
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;     211         PORTA = 0xff;
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;     212 
;     213         DDRB = 0xff;
	OUT  0x17,R30
;     214         DDRC = 0xff;
	OUT  0x14,R30
;     215         DDRD = 0xff;
	OUT  0x11,R30
;     216 
;     217 
;     218         TCCR0 = 0x06; // clk/256
	LDI  R30,LOW(6)
	OUT  0x33,R30
;     219         TCCR2 = 0x05; // clk/1024
	LDI  R30,LOW(5)
	OUT  0x25,R30
;     220         TCNT0 = 0xe3;
	LDI  R30,LOW(227)
	OUT  0x32,R30
;     221         TCNT2 = 0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     222         TIMSK = 0x41; // enable TOIE2, TOIE0
	LDI  R30,LOW(65)
	OUT  0x37,R30
;     223         /*
;     224         temp_led=1<<line;
;     225         temp_line=P[patt][line];
;     226 
;     227         PORTB = ~temp_line;
;     228         PORTC = temp_led;     // 
;     229 
;     230         //line++;
;     231         PORTD = ~temp_led;*/
;     232 
;     233         #asm("sei")
	sei
;     234 
;     235         while(1)
_0x16:
;     236         {
;     237                 /*
;     238                 if(M[mod][num_mod] == 0) {      //  
;     239                         mod= TCNT0%6;
;     240                         num_mod=0;
;     241 
;     242                         mov_chk_cnt++;
;     243 
;     244                         if(mov_chk_cnt == 10) {
;     245                         mov_chk_sw=0;
;     246                         mov_chk_cnt=0;
;     247                         }
;     248 
;     249                 }
;     250 
;     251                 else {
;     252                         patt= M[mod][num_mod];      //  
;     253                         num_mod++;
;     254                         if(delay<= DELAY) delay++;
;     255                 }
;     256 
;     257                 delay_ms(100);  */
;     258         };
	RJMP _0x16
;     259 }
_0x19:
	RJMP _0x19


;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x0:
	MOV  R30,R4
	LDI  R31,0
	CALL __LSLW3
	SUBI R30,LOW(-_P*2)
	SBCI R31,HIGH(-_P*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	MOVW R26,R30
	MOV  R30,R5
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	LPM  R10,Z
	MOV  R30,R5
	LDI  R26,LOW(1)
	CALL __LSLB12
	MOV  R13,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	MOV  R30,R7
	LDI  R26,LOW(25)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_M*2)
	SBCI R31,HIGH(-_M*2)
	MOVW R26,R30
	MOV  R30,R6
	RJMP SUBOPT_0x3

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__MODB21U:
	RCALL __DIVB21U
	MOV  R30,R26
	RET

;END OF CODE MARKER
__END_OF_CODE:
