/*
project     : Dotmatrix 8*8  BITMAN ǥ α׷
              bitman1.c
Date        : 2008-09-12
Company     : AvrMall.com
Chip type   : ATmega128-16au
Clock       : 16.000000 MHz
Comment     : 
BITMAN ̴ α׷̴.    Ѵ.
CL0~7 aTmega128 PORTB(line),  RW0~7 aTmega128 PORTC(LED) Ѵ.              
*/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega128


#pragma used+
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb RAMPZ=0x3b;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


typedef unsigned char u08;
typedef unsigned int  u16;


unsigned char line=0;
unsigned char patt=0;
unsigned char mod=0, num_mod=0;

unsigned char time=0;
unsigned char delay=100;

unsigned char dir=3;
unsigned char temp_led, temp_line;
unsigned char temp_dir;
unsigned int dir_cnt=0;

unsigned char dir_chk_sw=0;

unsigned char mov_chk_sw=1;           // üũ(    .)
unsigned char mov_chk_cnt=0;

unsigned char name_sw=0;

/*
迭 P  ۵ Ʈ Ʈ ǥõǴ ̰(ϳϳ )
迭 M  ۵  Ͽ ϳ  ǵ Ѵ.
*/

flash unsigned char M[6][25]={			
    {1,2,3,4,5,6,5,4,3,2,1,7,8,9,10,11,10,9,8,7,1,0,0,0,0},
    {12,13,14,13,12,13,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {15,16,17,16,15,18,19,18,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {20,21,22,21,20,23,24,23,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {25,26,27,28,29,30,31,32,29,30,31,32,0,0,0,0,0,0,0,0,0,0,0,0,0},
    {33,34,35,36,37,38,39,40,37,38,39,40,41,42,41,42,0,0,0,0,0,0,0,0,0}
};  

flash unsigned char P[43][8]={			
    {0x18,0x18,0x3c,0x5a,0x5a,0x24,0x24,0x66},  
    {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
    {0x18,0x18,0x3C,0xDA,0x1A,0x24,0x24,0x66},
    {0x0C,0xCC,0x3C,0x1A,0x1A,0x24,0x26,0x62},
    {0x8C,0x4C,0x3C,0x1A,0x1A,0x24,0x27,0x60},

    {0x4C,0x4C,0x3C,0x1A,0x1A,0x24,0x27,0x60},
    {0x2C,0x4C,0x3C,0x1A,0x1A,0x24,0x27,0x60},
    {0x18,0x18,0x3C,0x5B,0x58,0x24,0x24,0x66},
    {0x30,0x33,0x3C,0x58,0x58,0x24,0x24,0x66},
    {0x31,0x32,0x3C,0x58,0x58,0x24,0xE4,0x06},

    {0x32,0x32,0x3C,0x58,0x58,0x24,0xE4,0x06},
    {0x34,0x32,0x3C,0x58,0x58,0x24,0xE4,0x06},
    {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
    {0x00,0x18,0x7E,0x99,0x18,0x3C,0x24,0x66},
    {0x00,0x00,0xDB,0x3C,0x18,0x3C,0x3C,0x66},

    {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
    {0x18,0x18,0x3C,0xDA,0x1A,0x24,0x64,0x06},
    {0x30,0x30,0x9C,0x7A,0x19,0x24,0x64,0x06},
    {0x18,0x18,0x3C,0x5B,0x58,0x24,0x26,0x60},
    {0x0C,0x0C,0x39,0x5E,0x98,0x24,0x26,0x60},

    {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
    {0x0C,0x0C,0x7C,0x9A,0x1A,0x24,0x26,0x60},
    {0x00,0x06,0xFE,0x1C,0x1A,0x2A,0x28,0x6C},
    {0x30,0x30,0x3E,0x59,0x58,0x24,0x64,0x06},
    {0x00,0x60,0x7F,0x38,0x58,0x54,0x14,0x36},

    {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
    {0x18,0x18,0x3E,0x59,0x58,0x24,0x26,0x60},
    {0x0C,0x0C,0x18,0x3C,0x38,0x14,0x36,0x20},
    {0x0C,0x0C,0x38,0x5E,0x58,0x14,0x74,0x46},
    {0x0C,0x0C,0x38,0x3E,0x18,0x78,0x50,0x18},

    {0x00,0x0C,0x3C,0x58,0x5C,0x16,0x30,0x20},
    {0x0C,0x0C,0x78,0x9E,0x1C,0x14,0x76,0x40},
    {0x0C,0x0C,0x3F,0x58,0x18,0x34,0x24,0x06},
    {0x18,0x18,0x3C,0x5A,0x5A,0x24,0x24,0x66},
    {0x18,0x18,0x7C,0x9A,0x1A,0x24,0x64,0x06},

    {0x30,0x30,0x18,0x3C,0x1C,0x28,0x6C,0x04},
    {0x30,0x30,0x1C,0x7A,0x1A,0x28,0x2E,0x62},
    {0x30,0x30,0x7C,0x1A,0x18,0x16,0x12,0x30},
    {0x30,0x30,0x1C,0x7C,0x18,0x1E,0x0A,0x18},
    {0x00,0x30,0x3C,0x1A,0x3A,0x68,0x0C,0x04},

    {0x30,0x30,0x1E,0x79,0x38,0x28,0x6E,0x02},
    {0x30,0x30,0xFC,0x1A,0x18,0x2C,0x24,0x60},
    {0x30,0x30,0x3E,0x58,0x1C,0x24,0x26,0x60}

};

//
interrupt [17] void timer0_int(void)
{
        TCNT0 = 0xe3;  // reload for 448us ticks( : 460us)

        switch (dir){			//dir  ǥõǴ  Ѵ.
                case 0:
                        temp_led=1<<(7-line);
                        temp_line=P[patt][line];
                break;
                case 2:
                        temp_led=P[patt][line];
                        temp_line=1<<line;
                break;
                case 1:
                        temp_led=P[patt][7-line];
                        temp_line=1<<line;
                break;
                case 3:
                        temp_led=1<<line;
                        temp_line=P[patt][line];
                break;
        }

        PORTB = ~temp_line;
        PORTC = temp_led;     // 


        if(line==7) line=0;
        else line++;
        
        /*
        //    üũ
        if(dir_chk_sw == 0) {
                temp_dir = PINA>>6;
                dir_chk_sw=1;
        }
        if(temp_dir == PINA>>6){
                if(dir_cnt == 600 ) {
                        dir=temp_dir;
                        dir_cnt=0;
                }
                else {
                        dir_cnt++;
                }
        }
        else {
                if( delay >5) delay=delay-2;
                dir_chk_sw=0;
                dir_cnt=0;

                mov_chk_sw=1;
                mov_chk_cnt=0;
        }*/
}

interrupt [11] void timer2_ovf_isr(void)                  // ٲٱ  Ÿ̸ (Լ )
{                     
        TCNT2 = 0xdf;  // reload for 2.048ms ticks( : 2.12ms)
        time++;
        //PORTD.4 = ~PORTD.4;
        
        if(mov_chk_sw==1 && time >= delay )  //( : 214ms)
        {
                time=0;
                //PORTD.4 = ~PORTD.4;

                if(M[mod][num_mod] == 0) {      //  
                        mod= TCNT0%6;
                        num_mod=0;

                        mov_chk_cnt++;

                        if(mov_chk_cnt == 10) {
                        mov_chk_sw=0;
                        mov_chk_cnt=0;
                        }

                }

                else {
                        patt= M[mod][num_mod];      //  
                        num_mod++;
                        if(delay<= 100) delay++;
                }
        }
}

void main(void)
{
        DDRA = 0x00;
        PORTA = 0xff;
        
        DDRB = 0xff;
        DDRC = 0xff;
        DDRD = 0xff;
        

        TCCR0 = 0x06; // clk/256
        TCCR2 = 0x05; // clk/1024
        TCNT0 = 0xe3;
        TCNT2 = 0x00;
        TIMSK = 0x41; // enable TOIE2, TOIE0
        /*
        temp_led=1<<line;
        temp_line=P[patt][line];
        
        PORTB = ~temp_line;
        PORTC = temp_led;     // 
        
        //line++;
        PORTD = ~temp_led;*/
        
        #asm("sei")
        
        while(1)
        {       
                /*
                if(M[mod][num_mod] == 0) {      //  
                        mod= TCNT0%6;
                        num_mod=0;

                        mov_chk_cnt++;

                        if(mov_chk_cnt == 10) {
                        mov_chk_sw=0;
                        mov_chk_cnt=0;
                        }

                }

                else {
                        patt= M[mod][num_mod];      //  
                        num_mod++;
                        if(delay<= DELAY) delay++;
                }
                
                delay_ms(100);  */
        };
} 
